from Tkinter import *
import SM
reload(SM)
from SM import *

class ButtonDialog(PrimitiveSM):
    def __init__(self, top, parent, buttonNames, buttonResults=None,
                 doneButton = False):
        if buttonResults == None:
            buttonResults = buttonNames
        if doneButton:
            buttonNames = buttonNames + ["Done"]
            buttonResults.append("Done")
        self.result = StringVar()
        self.result.set("None")
        self.resultDict = makeDict(buttonNames, buttonResults)
        if parent == None:
            self.top = Toplevel(parent)
            self.frame = self.top
        else:
            self.top = top
            self.frame = Frame(parent)
        self.label = Label(self.frame, text="Input: ")
        self.label.pack()
        self.buttons = [Button(self.frame, text = name, state=DISABLED,
                               command = makeResultFn(self, name)) \
                        for name in buttonNames]
        for button in self.buttons:
            button.pack(padx=5, side=RIGHT)

        self.allDone = False

    def reset(self):
        print "Resetting ButtonDiag"
        self.allDone = False

    def enableButtons(self):
        for button in self.buttons:
            button.config(state = NORMAL)
        self.top.focus_set()

    def disableButtons(self):
        for button in self.buttons:
            button.config(state = DISABLED)

    def setResult(self, arg):
        self.result.set(arg)
        self.disableButtons()

    def step(self, input):
        # Display the input
        self.label.config(text = "Input: " + input)
        # Get a button press and return it
        self.enableButtons()
        self.top.wait_variable(self.result)
        result = self.resultDict[self.result.get()]
        if result == "Done":
            self.allDone = True
        return result

    def done(self):
        return self.allDone

def makeResultFn(obj, name):
    return lambda : obj.setResult(name)

def makeDict(keys, vals):
    dict = {}
    for key, val in zip(keys, vals):
        dict[key] = val
    return dict


######################################################
#
#   Test
# 
######################################################

def testButtons():
    top = Tk()
    identitySM = PrimitiveSM("id", lambda (sa): sa[1],
                             lambda (s): s[0], "start")
    
    testButtons = ButtonDialog(top, None, ["one", "two", "three"], None, True)
    sim = simulatorSM(identitySM, testButtons, "start")
    runSimulator(sim)




    
